#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char	*mat, *nam;
int  	reverse = 0;	/* boolean true for reversed normals */
double	sz[3];        /* wedge size */

main(argc,argv)
int     argc;
char    *argv[];
{

        if (argc < 6) {
		usage();
        }

        if (argc == 7) {
		if(argv[6][0]!='-')
			usage();
		else{
			if(argv[6][1]=='i'||argv[6][1]=='I')
				reverse = 1;	/* reversed normal */
			else
				usage();
		}
        }

	mat = argv[1];
	nam = argv[2];
        sz[0] = atof(argv[3]);
        sz[1] = atof(argv[4]);
        sz[2] = atof(argv[5]);

	torad();
}
/*____________________________________________________*/
torad()
{
	if(reverse == 0){
		printf("%s polygon %s.1 0 0 12 0 0 0 %.3f 0 0 %.3f %.3f 0 0 %.3f 0\n",
		mat,nam,sz[0],sz[0],sz[1],sz[1]);	/* BASE */

		printf("%s polygon %s.2 0 0 12 %.3f 0 0 %.3f %.3f 0 0 %.3f %.3f 0 0 %.3f\n",
		mat,nam,sz[0],sz[0],sz[1],sz[1],sz[2],sz[2]);	/* INCLINATED */

		printf("%s polygon %s.3 0 0 12 0 %.3f 0 0 0 0 0 0 %.3f 0 %.3f %.3f\n",
		mat,nam,sz[1],sz[2],sz[1],sz[2]);/* PERPENDICULAR */

		printf("%s polygon %s.4 0 0 9 0 0 0 %.3f 0 0 0 0 %.3f\n",
		mat,nam,sz[0],sz[2]);	/* TRIANG. FRONT */

		printf("%s polygon %s.5 0 0 9 0 %.3f 0 0 %.3f %.3f %.3f %.3f 0\n",
		mat,nam,sz[1],sz[1],sz[2],sz[0],sz[1]);	/* TRIANG. BACK */
	}
	else{
		printf("%s polygon %s.1 0 0 12 0 0 0 0 %.3f 0 %.3f %.3f 0 %.3f 0 0\n",
		mat,nam,sz[1], sz[0],sz[1],sz[0]);	/* BASE */

		printf("%s polygon %s.2 0 0 12 %.3f 0 0 0 0 %.3f 0 %.3f %.3f %.3f %.3f 0\n",
		mat,nam,sz[0],sz[2],sz[1],sz[2],sz[0],sz[1]);	/* INCLINATED */

		printf("%s polygon %s.3 0 0 12 0 %.3f 0 0 %.3f %.3f 0 0 %.3f 0 0 0\n",
		mat,nam,sz[1],sz[1],sz[2],sz[2]);	/* PERPENDICULAR */

		printf("%s polygon %s.4 0 0 9 0 0 0 0 0 %.3f %.3f 0 0\n",
		mat,nam,sz[2],sz[0]);	/* TRIANG. FRONT */

		printf("%s polygon %s.5 0 0 9 0 %.3f 0 %.3f %.3f 0 0 %.3f %.3f\n",
		mat,nam,sz[1],sz[0],sz[1],sz[1],sz[2]);	/* TRIANG. BACK */
	}
}
/*____________________________________________________*/
usage()
{
	fprintf(stderr,"-------------------------------------------------------- \n");
	fprintf(stderr,"genwedge is a Radiance utility for creating a wedge\n");
	fprintf(stderr,"primitive\n");
	fprintf(stderr,"Abraham Yezioro, Fac. of Architecture - TECHNION, Israel \n");
	fprintf(stderr,"-------------------------------------------------------- \n");
	fprintf(stderr,"genwedge usage:\n");
	fprintf(stderr,"genwedge mat name xsize ysize zsize [-i] \n\n");
	fprintf(stderr,"show_type : s - Surfaces, w - wire frame\n");
	fprintf(stderr,"the -i option can be used to produce a wedge with inward\n");
	fprintf(stderr,"directed surface normals.\n");
	fprintf(stderr,"Example:\n");
	fprintf(stderr,"To create a wedge of 5 X units and 2.5 Y units with a height\n");
	fprintf(stderr,"of 3 Z units looks like this:\n\n");
	fprintf(stderr,"genwedge red_plastic wg1 5 2.5 3\n\n\n");
        exit();
}
